"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = sendQuery;

function sendQuery(query) {
  var _this = this;

  if (this.pendingQueries.indexOf(query) > -1) return;
  this.pendingQueries = this.pendingQueries.concat(query);

  var endpoint = this.props.endpoint;
  var parsedSchema = this.parsedSchema;
  var store = this.store;
  var dispatch = store.dispatch;

  request(endpoint, { query: query }).then(function (json) {
    dispatch({
      type: UPDATE_CACHE,
      payload: normalize(parsedSchema, json.data)
    });
    _this.pendingQueries = _this.pendingQueries.filter(function (p) {
      return p === request;
    });
  })["catch"](function (err) {
    dispatch({ type: UPDATE_CACHE, payload: err, error: true });
    _this.pendingQueries = _this.pendingQueries.filter(function (p) {
      return p === request;
    });
  });
}

module.exports = exports["default"];