'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = request;

function request(endpoint, data, files) {
  if (data.query) {
    var query = encodeURIComponent(data.query);
    var variables = encodeURIComponent(JSON.stringify(data.params));
    return fetch(endpoint + '?query=' + query + '&variables=' + variables).then(parseJSON);
  }
  if (data.mutation) {
    var formData = new FormData();
    formData.append('query', data.mutation);
    formData.append('variables', JSON.stringify(data.params));
    if (files) {
      for (var i = 0; i < files.length; i++) {
        formData.append('files', files[i], files[i].name);
      }
    }
    return fetch(endpoint, {
      method: 'post',
      body: formData
    }).then(parseJSON);
  }

  throw new Error('Unsupported request');
}

function parseJSON(res) {
  return res.json();
}
module.exports = exports['default'];