'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = parseSchema;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _lodash = require('lodash');

var _graphql = require('graphql');

function parseSchema(schema) {
  var typeMap = schema.getTypeMap();
  var userTypes = (0, _lodash.reduce)(typeMap, function (acc, val, key) {
    if (!isDefinedType(key)) return acc;
    return _extends({}, acc, _defineProperty({}, key, _extends({}, (0, _lodash.reduce)(val.getFields(), function (memo, field, name) {
      var typename = parseType(field.type, isDefinedType);
      return typename !== undefined ? _extends({}, memo, _defineProperty({}, name, typename)) : memo;
    }, {}))));
  }, {});
  return userTypes;
}

function parseType(_x) {
  var _again = true;

  _function: while (_again) {
    var type = _x;
    complexType = typename = undefined;
    _again = false;

    var complexType = type instanceof _graphql.GraphQLList || type instanceof _graphql.GraphQLScalarType || type instanceof _graphql.GraphQLObjectType;
    if (!complexType) {
      _x = type.ofType;
      _again = true;
      continue _function;
    }
    if (type instanceof _graphql.GraphQLList) {
      var typename = type.ofType.name;
      return isDefinedType(typename) ? [typename] : undefined;
    }
    return isDefinedType(type.name) ? type.name : undefined;
  }
}

function isDefinedType(typename) {
  return !isIntrospectionType(typename) && !isBuiltInScalar(typename);
}

function isIntrospectionType(typename) {
  return typename.indexOf('__') === 0;
}

function isBuiltInScalar(typename) {
  return typename === 'String' || typename === 'Boolean' || typename === 'Int' || typename === 'Float' || typename === 'ID';
}
module.exports = exports['default'];